/**
 * An illustration of two simultaneous threads that print something.
 * In this version, the test method and the run() method have been combined
 * into one class.  I've also, coincidentally, removed the local variables
 * tastesGreat and lessFilling.
 * 
 * @author Stephen Bloch (based on an example at http://java.sun.com/docs/books/tutorial/essential/threads/simple.html)
 * @version 12 April 2005, version 3
 */
public class DuelingPrints implements Runnable
{
    private String label;
    private int steps;
    /**
     * Constructor for objects of class DuelingPrints
     * @param label to identify this thread
     * @param steps how many steps this thread will take
     */
    public DuelingPrints(String label, int steps)
    {
        this.label = label;
        this.steps = steps;
    }

    public static void test () {
        System.out.println ("About to start everything...");
        new Thread(new DuelingPrints ("Less Filling", 5)).start();
        new Thread(new DuelingPrints ("Tastes Great", 6)).start();
        System.out.println ("Started everything!");
    }
    
    public void run () {
        while (steps > 0) {
            System.out.println (this.label + ": " + this.steps);
            --steps;
            try {
                Thread.sleep ((long)(Math.random() * 1000));
            }
            catch (InterruptedException e) {}
        }
    }
}
